/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is CopySent2Current.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//Attention: the 'no copy' does not work, if sending a message in offline modus
//          (messages are delivered to the 'sent'-folder)

if(!de) var de={};
if(!de.ggbs) de.ggbs={};
if(!de.ggbs.cs2c) de.ggbs.cs2c={};

if (!de.ggbs.cs2c.mc) de.ggbs.cs2c.mc = function() {
////////////////////////

  var gBase=0x100;
  var gSentAlso=0x10;
  var gTrash=0x20;
  var gDefSent=0x1;

  /* for TB3 see mailnews/base/public/nsMsgFolderFlags.idl
  var gFlagList = { 'MSG_FOLDER_FLAG_VIRTUAL' : 0x0020,
                    'MSG_FOLDER_FLAG_TRASH' : 0x0100,
                    'MSG_FOLDER_FLAG_SENTMAIL' : 0x0200,
                    'MSG_FOLDER_FLAG_DRAFTS' : 0x0400,
                    'MSG_FOLDER_FLAG_QUEUE' : 0x0800,
                    'MSG_FOLDER_FLAG_INBOX' : 0x1000,
                    'MSG_FOLDER_FLAG_TEMPLATES' : 0x400000,
                    'MSG_FOLDER_FLAG_JUNK' : 0x40000000 };
  */
  var gSpecialFolders=0x0100|0x0400|0x0800|0x400000|0x40000000;

  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].
          getService(Components.interfaces.nsIRDFService);
  var dir = rdf.GetResource("moz-abdirectory://")
              .QueryInterface(Components.interfaces.nsIAbDirectory);
  var TB3=dir.directoryProperties?false:true;  //true since TB3

  var gConsole;
  var gScriptError;

  var gPreSelected='';

  var gDefaultLabel=null;
  var gDefaultURI=null;

  var gAllowChoose=true;

  var pub = {
    gChooseBehind: false,  //from preferences
    gNocopyTest:   false,  //nocopy crash test?
    gMsgType:      0,
    gPrefB: Components.classes["@mozilla.org/preferences;1"].
                getService(Components.interfaces.nsIPref).
                getBranch("extensions.copysent2current.")

  };
  //public function are define as
  //  pub.name = function(args) {...}
  //and must be called as de.ggbs.cs2c.mc.name
  //
  //Internal functions are defined normally as
  //  function name(args) {...}
  //and are called without 'this.'

  /////////////////////////////////////////////////////////////////////////////
  // set the fcc_folder, so sendMsg will use it
  pub.prepareForCopy = function() {
    //within this function, the variables have to be used as
    //  de.ggbs.cs2c.mc.gMsgType, not just this.gMsgType!!
    if (de.ggbs.cs2c.mc.gMsgType==nsIMsgCompDeliverMode.SaveAsDraft ||
        de.ggbs.cs2c.mc.gMsgType==nsIMsgCompDeliverMode.SaveAsTemplate ||
        de.ggbs.cs2c.mc.gMsgType==nsIMsgCompDeliverMode.AutoSaveAsDraft )
      return;

  //Get current identity
    var identity=window.getCurrentIdentity();
    if (!identity.doFcc || identity.fccFolderPickerMode<gBase)
      //no copy requested or copy to fixed folder (standard tb modes)
      return;

    var msgCompFields = gMsgCompose.compFields;
    // wenn kein to angegeben, liefert CheckValidEmailAddress() trotzdem true und
    // dies wird aufgerufen, obwohl das senden spter nicht ausgefhrt wird!
    if (!msgCompFields.to) return

    // msgCompFields.fcc is empty
    var picker=document.getElementById('de.ggbs.cs2c.fccFolderPicker');
    if (!gPreSelected) {
      //If 'choose after send' is enabled, show the menu
      if (de.ggbs.cs2c.mc.gChooseBehind && gAllowChoose) {
          //.open() throws exception!
        //var left=window.left+200;
        //var top=window.top+200;
        var chooser=window.openDialog("chrome://copysent2current/content/chooser.xul","cs2c_chooser",
            'chrome=yes,modal=yes,titlebar=yes,alwaysRaised=yes,dialog=yes,close=no',//,left='+left+',top='+top,
            gDefaultLabel, gDefaultURI);
      }
      var targeturi=picker.getAttribute("uri");
      if (targeturi!="nocopy://"
          && !(window.getCurrentIdentity().fccFolderPickerMode&gDefSent && targeturi==gDefaultURI)
                                         // nicht den sentfolder, wenn er der default ist
      ) {
        de.ggbs.cs2c.mc.CS2C.add_URI(targeturi); //save this uri in the list
        if (!de.ggbs.cs2c.mc.gChooseBehind)
          de.ggbs.cs2c.mc.fillElems();         //and rebuild menu, if necessary
      }
      msgCompFields.fcc = targeturi;
    } else if (gPreSelected=='noCopy') {
      msgCompFields.fcc = "nocopy://";
    } else if (gPreSelected=='toSentFolder') {
      msgCompFields.fcc = identity.fccFolder;
    }
    gPreSelected='';

    // change nocopy:// to trash folder if requested
    if (TB3 && de.ggbs.cs2c.mc.gNocopyTest)                       //nocopy crash test?
      identity.fccFolderPickerMode&=~gTrash;      //  nocopy is always a real nocopy
      else
    if (TB3)                                              //wg BUG in TB3 with nocopy://
      identity.fccFolderPickerMode|=gTrash;               //  nocopy is always copy to trash
    if (identity.fccFolderPickerMode&gTrash && msgCompFields.fcc=='nocopy://') {
      //find the Trash folder and be sure this folder is a trash folder
      var trashFolderURI=identity.fccFolder.replace(/[^\/]*$/,'Trash');
      /* check if trashfolder really is a trash folder */
      if (typeof MailUtils=='object') { //since TB3b3
        trashFolder=MailUtils.getFolderForURI(trashFolderURI);
      } else {  //TB2-TB3b2, Eudora
        trashFolder=GetMsgFolderFromUri(trashFolderURI);
      }
      var flags=Components.interfaces.nsMsgFolderFlags?
          Components.interfaces.nsMsgFolderFlags.Trash: //TB3
          0x0100;                                       //TB2: commandglue.js: var MSG_FOLDER_FLAG_TRASH = 0x0100;
      if (trashFolder.flags&flags) {
        msgCompFields.fcc=trashFolderURI;
      } else {
        var prompter = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
          getService(Components.interfaces.nsIPromptService);
        var strings = document.getElementById("de.ggbs.cs2c.strings");
        var ret=prompter.alert(window, strings.getString('CopySent2Current'), strings.getString('NoTrashFolder'));
        msgCompFields.fcc=identity.fccFolder;
      }
    }

    msgCompFields.fcc2='nocopy://';
    if (identity.fccFolderPickerMode&gSentAlso && msgCompFields.fcc != identity.fccFolder) { // also to sent folder
      if (msgCompFields.fcc=='nocopy://') {
        msgCompFields.fcc  = identity.fccFolder;
      }
      // since fcc2 is only performed when fcc succeeded, we want to be sure
      // that the 'easier'(=copy to a local folder) is done first
      else if (identity.fccFolder.substr(0,7)!='imap://' &&             // if send folder is local
                 msgCompFields.fcc.substr(0,7)=='imap://') {            // and fcc folder is remote
        msgCompFields.fcc2 = msgCompFields.fcc;                         //   change them
        msgCompFields.fcc  = identity.fccFolder;
      } else {
        msgCompFields.fcc2 = identity.fccFolder;
      }
    }

  dump('CopySent2Current: fcc  to '+msgCompFields.fcc+'\n');
  dump('                  fcc2 to '+msgCompFields.fcc2+'\n');
  }

  //not really used!
  pub.SelectionChange = function (event, picker) {
    var uri=picker.getAttribute("uri");
  }

  /////////////////////////////////////////////////////////////////////////////
  // preselect the current (or another) folder in the 'copy-to'-picker
  // or hide the picker, if not useable
  pub.fillMenu = function(event, origURI) {
      //origURI: MessageURI if its a reply

    var state='';
    var menu=document.getElementById('de.ggbs.cs2c.toolbar');
    var identity=window.getCurrentIdentity();
    if (identity.doFcc && identity.fccFolderPickerMode>=gBase) {
      try {
  	    gAllowChoose=true;
  	    menu.hidden=this.gChooseBehind;
  	    var sendTo='';

  	    var folder;
  	    if (identity.fccFolderPickerMode&gDefSent) {         // Sent folder is default
  	      sendTo=identity.fccFolder;
          state='isSentFolder';
        } else if (origURI) { //preselect current folder
  	       //for replies, current folder is the folder of the message replied to!
          state='answer';
          var messenger = Components.classes['@mozilla.org/messenger;1'].createInstance().
              QueryInterface(Components.interfaces.nsIMessenger);
          var msgHdr=messenger.msgHdrFromURI(origURI);
          folder=msgHdr.folder;
  	    } else { //try to find the currently selected folder
          state='defaultFolder';
  	      var mailWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
  	                       .QueryInterface(Components.interfaces.nsIWindowMediator)
  	                       .getMostRecentWindow("mail:3pane");
  	      if (mailWindow) {     //else: no main window
            state+=' window';
  	        var View=mailWindow.gDBView;  //nsIMsgDBView
  	        if (View) {         // else: no folder selected!
              state+=' view';
  	          folder=View.msgFolder;
  	          // wenn 'new' geklicked
  	          //TB3b4: wenn tab mit message aktiv, ist das der folder der message,
  	          //         nicht der folder aus dem 3pane tab
  	          //       aus einem der neuen suchergebnis fenster gibts zwar den view,
  	          //         aber der hat keinen folder
  	          //       wenn message in eigenem Window (vom 3pane tab aus), sollte eventuell der folder
  	          //         der angezeigten message genommen werden, nicht aus 3pane window (kein Ahnung wie)
  	          //       wenn message in eigenem Window (aus suchergebnis heraus),
  	          //         gibts keinen folder
  	        }
  	      }
  	    }
        state+=' check';
   	    if (folder && folder.canFileMessages     // not news Folder, virtual folder
      	//        && !(folder.flags&gSpecialFolders)   // not a special folder
        ) {
           state+=' getURI';
           sendTo=folder.URI;
        }
      	//else if (folder) alert('special folder');
      	//else if (!sendTo) alert('no folder');
  	    if (!sendTo) //last resort: preselect last used folder
  	      sendTo=identity.fccFolder;
      } catch(e) {
        if (!gConsole) gConsole = Components.classes["@mozilla.org/consoleservice;1"]
                                  .getService(Components.interfaces.nsIConsoleService);
        if (!gScriptError) gScriptError = Components.classes["@mozilla.org/scripterror;1"]
                                  .createInstance(Components.interfaces.nsIScriptError);
        gScriptError.init('CopySent2Current: Error initializing  ('+e.message+')\n  State: '+state+'\n',
                /*aSourceName*/null, /*aSourceLine*/null, /*aLineNumber*/null,
                       /*aColumnNumber*/null, /*nsIScriptError.warningFlag*/1, '');
        gConsole.logMessage(gScriptError);
      }

      //Set chooser to the default (if choose behind: just to get uri and label!)
        //from chrome:://messenger/content/msgFolderPickerOverlay.js #88ff
      SetFolderPicker(sendTo, "de.ggbs.cs2c.fccFolderPicker");
      var picker=document.getElementById('de.ggbs.cs2c.fccFolderPicker');
      gDefaultLabel=picker.getAttribute("label");
      gDefaultURI=picker.getAttribute("uri");

      if (!this.gChooseBehind) {
        var menu=document.getElementById('de.ggbs.cs2c.copyMenuPopup');
        var def=menu.firstChild;
        def.label  = gDefaultLabel;
        def.id     = gDefaultURI;
        this.fillElems();
      }
    } else {
      gAllowChoose=false;
      menu.hidden=true;
    }
  }

  /////////////////////////////////////////////////////////////////////////////
  pub.picked = function(chooser, picked) {
    var uri=picked.id;
    var picker=document.getElementById('de.ggbs.cs2c.fccFolderPicker');
    if (uri=='nocopy://') {
      picker.setAttribute("label",picked.getAttribute("label"));
      picker.setAttribute("uri",uri);
    } else {
      //from chrome:://messenger/content/msgFolderPickerOverlay.js #88
      SetFolderPickerElement(uri, picker);
        //Does the following, and adds the '... in server' text to the picker
        //  picker.setAttribute("label",picked.getAttribute("label"));
        //  picker.setAttribute("uri",uri);
    }
    if (chooser) {
      chooser.close();
      chooser=null;
    }
  //  var goto=document.getElementById('msgSubject'); //'content-frame');//
  //  goto.focus();
  }
  pub.showPopup = function() {
    // called via a timeout! This prevents using the keystroke as navigation in the popup,
    // if the menulist gots focus via keyboard-shortcut
    var popup=document.getElementById('de.ggbs.cs2c.copyMenuPopup');
    if (!TB3)
      popup.showPopup(popup,-1,-1,'popup','topleft','topleft'); //deprecated; use:
    else
      popup.openPopup(popup, 'after_start', -1, -1, false, false);
  }

  // Register a state listener so that we know, the message has been sent.
  // reset the fcc_folder to the 'sent' folder

  /*
  var cs2c_stateListener = {
    NotifyComposeFieldsReady: function() {
  //dump('NotifyComposeFieldsReady\n');
    },


    // Message send (or copied to outbox, if offline)
    ComposeProcessDone: function(aResult) {
  //dump('ComposeProcessDone\n');
    },

    SaveInFolderDone: function(folderURI) {
  //dump('SaveInFolderDone\n');
    }

  };
  */

  /////////////////////////////////////////////////////////////////////////////
  pub.init = function() {

    try {
      var ak_s = this.gPrefB.getCharPref("accesskey_send");
      document.getElementById('de.ggbs.cs2c.key_sendNoCopy').setAttribute('key',ak_s);
      document.getElementById('de.ggbs.cs2c.key_sendCopy2Sent').setAttribute('key',ak_s);
    } catch(e) { }

    //Overload functions
  /*  (only, if we registered the state listener)
    var cs2c_ComposeUnload=window.ComposeUnload;
    // and replace with my version...
    window.ComposeUnload=function() {
  //  if (gMsgCompose) gMsgCompose.UnregisterStateListener(cs2c_stateListener);
      return cs2c_ComposeUnload.apply(this, arguments);
    }
  */

/*
      // Overload from chrome://messenger/content/msgComposeCommands.js @line 1646
      // so we have a chance to get the type of the message
      // because we do not want to set .fcc and .fcc2 on SaveAsDraft and others
    var cs2c_GenericSendMessage=window.GenericSendMessage;
    window.GenericSendMessage=function() {
      gMsgType=arguments[0];
      return cs2c_GenericSendMessage.apply(this, arguments);
    }
*/
  }

  pub.Controller =
  {
    supportsCommand: function(command)
    {
  //dump("cs2c: supportsCommand: "+command+"\n");
      switch (command)
      {
        case "de.ggbs.cs2c.cmd_sendNoCopy":
        case "de.ggbs.cs2c.cmd_sendCopy2Sent":
          return true;
        default:
          return false;
      }
    },
    isCommandEnabled: function(command)
    {
  //dump("cs2c: isCommandEnabled: "+command+"\n");
      switch (command)
      {
        case "de.ggbs.cs2c.cmd_sendNoCopy":
        case "de.ggbs.cs2c.cmd_sendCopy2Sent":
          var identity=window.getCurrentIdentity();
          if (!identity.doFcc || identity.fccFolderPickerMode<gBase) return false;
          return !gWindowLocked;
        default:
          return false;
      }
    },

    doCommand: function(command)
    {
  //dump("cs2c: doCommand: "+command+"\n");
      switch (command)
      {
        case "de.ggbs.cs2c.cmd_sendNoCopy":
          if (de.ggbs.cs2c.mc.Controller.isCommandEnabled(command)) {
            gPreSelected='noCopy';
            if (gIOService && gIOService.offline)
              SendMessageLater();
            else
              SendMessage();
          }
          break;
        case "de.ggbs.cs2c.cmd_sendCopy2Sent":
          if (de.ggbs.cs2c.mc.Controller.isCommandEnabled(command)) {
            gPreSelected='toSentFolder';
            if (gIOService && gIOService.offline)
              SendMessageLater();
            else
              SendMessage();
          }
          break;
        default:
          return;
      }
    },

    onEvent: function(event)
    {
  //dump("DefaultController:onEvent\n");
    }
  }

  return pub;

}();


/////////////////////////////////////////////////////////////////////////////
// Overload from chrome://messenger/content/msgComposeCommands.js @line 1163
// not via init(), because that might be too late!
function ComposeStartup(recycled, aParams) {
  de.ggbs.cs2c.ol.savedComposeStartup(recycled, aParams);   // call original
//  gMsgCompose.RegisterStateListener(cs2c_stateListener);  // i want to know state changes

  //see original ComposeStartup
  var params=null;
  var origURI=null;
  if (aParams)
    params = aParams;
  else
    if (window.arguments && window.arguments[0]) {
      try {
        if (window.arguments[0] instanceof Components.interfaces.nsIMsgComposeParams)
          params = window.arguments[0];
        else
          params = handleMailtoArgs(window.arguments[0]);
      }
      catch(ex) { dump("ERROR with parameters: " + ex + "\n"); }
    }
  if (params) origURI=params.originalMsgURI;

  try { de.ggbs.cs2c.mc.gChooseBehind = de.ggbs.cs2c.mc.gPrefB.getBoolPref("choosebehind"); }
    catch(e) { de.ggbs.cs2c.mc.gChooseBehind=false; }
  if (!de.ggbs.cs2c.mc.gChooseBehind) de.ggbs.cs2c.mc.addElems();
  de.ggbs.cs2c.mc.fillMenu(null, origURI);    // and preselect the current folder in the copy to picker
  document.getElementById('fccMenu').disabled=true;

  //nocopy crash test?
  try { de.ggbs.cs2c.mc.gNocopyTest = de.ggbs.cs2c.mc.gPrefB.getBoolPref("nocopytest"); }
    catch(e) { de.ggbs.cs2c.mc.gNocopyTest=false; }
}

// Overload from chrome://messenger/content/msgComposeCommands.js @line 1646
// so we have a chance to get the type of the message
// because we do not want to set .fcc and .fcc2 on SaveAsDraft and others
window.GenericSendMessage=function() {
  de.ggbs.cs2c.mc.gMsgType=arguments[0];
  return de.ggbs.cs2c.ol.savedGenericSendMessage.apply(this, arguments);
}

top.controllers.insertControllerAt(0, de.ggbs.cs2c.mc.Controller);

// Call when the window is fully loaded, prevent racing condition
window.addEventListener("load", de.ggbs.cs2c.mc.init, false);


window.addEventListener('compose-from-changed', de.ggbs.cs2c.mc.fillMenu, true);   // change of identity! (last param must be true!)
window.addEventListener('compose-send-message', de.ggbs.cs2c.mc.prepareForCopy, true); // fires after the observer 'mail:composeOnSend'
//not necessary, because of 'ComposeStartup' called:
//window.addEventListener('compose-window-reopen', de.ggbs.cs2c.mc.fillMenu, true);

